#include <Adafruit_MotorShield.h>

#include <Adafruit_PWMServoDriver.h>

#include <Wire.h>
#include <Adafruit_MotorShield.h>
//#include "utility/Adafruit_PWMServoDriver.h"

Adafruit_MotorShield AFMS = Adafruit_MotorShield(); 
Adafruit_StepperMotor *myMotor = AFMS.getStepper(400, 1);

//Code:
// #define DEBUG 1                                    // comment out this line to remove debuggin Serial.print lines
int M = (1,2);
// Declare pins
//int STEP[] = {2,5};    // Step Pins,  active HIGH
//int DIR[] = {3,6};     // Direction Pins, active HIGH
//byte DIR_ACTIVE[] = {LOW, LOW};

word direction = FORWARD;
const int kAxisCount = 2;                          // how many axis we are handling

unsigned int Pos[] = {32727,32727}; //Position logging

const char kAxisName[kAxisCount] = {'R','P'};    // the letters ("names") sent from Sim Tools to identify each axis
//const int kAxisScale[kAxisCount][6] = { {0,999},{0,999},{0,999},{0,999},{0,999},{0,999} };  //Scaling
const char kEOL = '~';                             // End of Line - the delimiter for our acutator values
const int kMaxCharCount = 5;                       // some insurance to 8 bit...
unsigned int axisPosition[kAxisCount] = {32727,32727};         // current Axis positions, initialised to 127 middle for 8 bit
int currentAxis;                                   // keep track of the current Axis being read in from serial port
int valueCharCount = 0;                            // how many value characters have we read (must be less than kMaxCharCount!!

// set up some states for our state machine
// psReadAxis = next character from serial port tells us the Axis info that follows
// psReadValue = next characters from serial port until we hit our kMaxCharCount or kEOL which tells us the value
enum TPortState { psReadAxis, psReadValue };  
TPortState currentState = psReadAxis;

void setup()  {
  Serial.begin(115200);
 
  // Define pins
  for (int i=0; i < kAxisCount; i++)  {
    //pinMode(STEP[i], OUTPUT);
    //pinMode(DIR[i], OUTPUT);
//    word direction = forward;
    AFMS.begin();
    myMotor->setSpeed(300);
    myMotor->onestep(FORWARD, DOUBLE);
  }
}

void loop()
{
for (int i = 0; i < kAxisCount; i++) {
// check new position
if (Pos[i] != axisPosition[i])  { 
 
  // check direction and write DIR pin
  if (Pos[i] >= axisPosition[i])  { 
  myMotor->quickstep(FORWARD);
  //direction = FORWARD;
  //digitalWrite(DIR[i], LOW);
  Pos[i] = Pos[i] - 1;
    }
   
  if (Pos[i] < axisPosition[i])  { 
  myMotor->quickstep(BACKWARD);
  //direction = BACKWARD;
  //digitalWrite(DIR[i], HIGH);
  Pos[i] = Pos[i] + 1;
    }
   
     //myMotor->step(1, direction, DOUBLE);
    // make one step
    //digitalWrite(STEP[i], HIGH);
    //delayMicroseconds(500);
    //digitalWrite(STEP[i], LOW);
    //delayMicroseconds(500);
   
    //break;
}}}

// this code only runs when we have serial data available. ie (Serial.available() > 0).
void serialEvent() {
    char tmpChar;
    int tmpValue;

    while (Serial.available()) {
        // if we're waiting for a Axis name, grab it here
        if (currentState == psReadAxis) {
            tmpChar = Serial.read();
           
#ifdef DEBUG           
Serial.print("read in ");           
Serial.println(tmpChar);           
#endif
        for (int i = 0; i < kAxisCount; i++) {    // look for our axis in the array of axis names we set up
        if (tmpChar == kAxisName[i]) {
#ifdef DEBUG           
Serial.print("which is axis ");           
Serial.println(i);           
#endif
                    currentAxis = i;                            // remember which axis we found
                    currentState = psReadValue;                 // start looking for the Axis position
                    axisPosition[currentAxis] = 0;              // initialise the new position
                    valueCharCount = 0;                         // initialise number of value chars read in
                    //break;
                }
            }
        }
       
        // if we're ready to read in the current Axis position data
        if (currentState == psReadValue) {
            while ((valueCharCount < kMaxCharCount) && Serial.available()) {
                tmpValue = Serial.read();
                if (tmpValue != kEOL) {
                    tmpValue = tmpValue - 48;
                    if ((tmpValue < 0) || (tmpValue > 9)) tmpValue = 0;
                    axisPosition[currentAxis] = axisPosition[currentAxis] * 10 + tmpValue;
                    valueCharCount++;
                }
                else break;
            }
           
            // if we've read the value delimiter, update the Axis and start looking for the next Axis name
            if (tmpValue == kEOL || valueCharCount == kMaxCharCount) {
             
             
              // scale the new position so the value is between 0 and 179
              //axisPosition[currentAxis] = map(axisPosition[currentAxis], 0, 255, kAxisScale[currentAxis][0], kAxisScale[currentAxis][1]);
               //updateAxis(currentAxis);
             
#ifdef DEBUG           
Serial.print("read in ");           
Serial.println(axisPosition[currentAxis]); 
Serial.print("Position ");           
Serial.println(Pos[currentAxis]);  
#endif
               
                currentState = psReadAxis;
            }
        }
    }
}
